;;; $Id: ch5-7-1.tst,v 1.1 1999/04/25 16:23:52 leavens Exp $

(load-quietly-from-lib "run.scm")

(run-regression-tests-equal?
 `(
    ( (run "let three = 3
            in let add3 = proc(i) +(i, three);
                   three = 5
               in *(three, add3(2))")
      ==> 35 )
    ( (run "let a = 3
            in let p = proc() +(x, a);
                   f = proc(x, y) *(p(), y);
                   a = 5
               in *(a, f(let a = 2 in a, 1))")
      ==> 35 )
    ( (run "let a = 3
            in let p = proc() +(x, a);
                   f = proc(x, a) *(p(), a);  %% ***
                   a = 5
               in *(a, f(let a = 2 in a, 1))")
      ==> 15 )
    ( (run "let a = 3
            in let p = proc() +(x, a);
                   f = proc(x, y) *(p(), y);
                   a = 5
               in *(a, let a = 2 in f(a, 1))")
      ==> 20 )

    )
 )
