;;; $Id: leaf-sum.scm,v 1.5 1999/03/01 16:23:09 leavens Exp $

(load-quietly-from-lib "binary-tree-of-num.scm")

;;; modified from EOPL p. 80

(define leaf-sum
  ;; TYPE: (-> (tree) number
  (lambda (tree)
    (cond
     ((leaf? tree)
      (leaf->number tree))
     ((interior? tree)
      (+ (leaf-sum (interior->left-tree tree))
	 (leaf-sum (interior->right-tree tree))))
     (else (error "leaf-sum: Invalid tree " tree)))))
