;;; $Id: parsed-exp-extended.scm,v 1.2 1999/04/26 20:15:44 leavens Exp $
;;; Abstract syntax for the defined language's expressions

;;; The following need their own .def files.

(load-quietly-from-lib "parsed-exp.scm")
(load-quietly-from-lib "record-clause.scm")
(load-quietly-from-lib "record-one-case.scm")

;;; New abstract syntax

(define-record unless-exp (test-exp body))
(define-record when-exp (test-exp body))
(define-record cond-exp (clauses))
(define-record case-exp (exp cases))
(define-record repeat-exp (var final-val body))
(define-record for (var lower-exp upper-exp body))
(define-record foreach (var list-exp body))
(define-record while (test-exp body))
(define-record do-until (body test-exp))
(define-record run-while (body test-exp))
(define-record multiassign (vars exps))
(define-record and-exp (left-exp right-exp))
(define-record or-exp (left-exp right-exp))
(define-record implies-exp (left-exp right-exp))
(define-record within-use (body decls))
(define-record with-do (decls body))
