;;; $Id: seq-record.scm,v 1.1 1998/10/08 01:57:02 leavens Exp $

;;; INFINITE SEQUENCS AS RECORDS

(define-record repeated-seq  (num))
(define-record generated-seq (f))

(define seq-repeat make-repeated-seq)
(define seq-generator make-generated-seq)

(define-record added-seq (s1 s2))
(define seq-add make-added-seq)

(define seq-nth
  (lambda (seq n)
    (variant-case seq
      (repeated-seq (num) num)
      (generated-seq (f) (f n))
      (added-seq (s1 s2)
	 (+ (seq-nth s1 n)
	    (seq-nth s2 n)))
      (else (error "invalid sequence"
		   seq)))))

