;;; $Id: type-check-compute-global-var-types.scm,v 1.1 1999/06/23 16:57:22 leavens Exp $
;;; Types for built-in Scheme procedures
;;; AUTHORS: Curtis Clifton and Gary T. Leavens,
;;;          from an earlier verison by Steven L. Jenkins.

(load-quietly-from-lib "type-check-global-var-external-types.scm")
(load-quietly-from-lib "type-check-compute-cxr-types.scm")

(define *tc:pre-global-var-types*
  ;; TYPE: (env symbol type-expr)
  (tc:env-map
   (lambda (p)
     ;; TYPE: (-> ((pair symbol external-type-expr)) (pair symbol type-expr))
     (cons (car p)
	   (tc:type-untranslate (cdr p))))
   (tc:env-join *tc:pre-global-var-external-type-env* *tc:cxr-external-type-env*)))
